//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""


//---- input parameters
extern int       TakeProfit = 50;
extern int       StopLoss = 50;
extern double    Lots = 0.01;

int		 			Magic = 999;

int BuyTicket = 0, 
	SellTicket = 0;
	

static int prevtime = 0;

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
double 	i1, i2, i3,  io1, io2, io3,
		i21, i22, i23, 
		i31, i32, i33,
		otstup = Point * 1,
		CHV1;

	//    
   if(Time[0] == prevtime) 
       return(0);
   prevtime = Time[0];


	if (OrdersTotal() < 1) {
	BuyTicket = 0;
	SellTicket = 0;
	}

	/*   
	    ...
	  
	
	extern int     MA_Price   =0; //Applied Price: 0-C,1-O,2-H,3-L,4-Median,5-Typical,6-Weighted
	extern int     MA_Length  =1; //MA's Period 
	extern int     MA_Mode    =0; //MA's Method:0-SMA,1-EMA,2-SMMA,3-LWMA  
	extern int     ATR_Length =10;//ATR's Period
	extern double  Kv         =4; //Volatility's Factor or Multiplier
	extern double  MoneyRisk  =1; //Offset Factor 
	extern bool    usePrice_HiLoBreak    =true;
	extern bool    useMA_HiLoEnvelope    =false;
	extern int     AlertMode  =0; //0-alert off,1-on
	extern int     VisualMode =0; //0-lines,1-dots 
	extern string Applied_Price_ ="0-C,1-O,2-H,3-L,4-Median(H+L)/2,5-Typical(H+L+C)/3,6-Weighted(H+L+C+C)/4";
	extern string MAmethod_mode_ ="0-SMA,1-EMA,2-SMMA,3-LWMA";
	extern string Visual_Mode___ ="0-lines,1-dots ";
	*/
   
	i1 = iCustom(NULL, 0, "VoltyChannel_Stop_v2.1M", 0, 1, 0, 10, 4, 1, true, false, 0, 0, 
				"0-C,1-O,2-H,3-L,4-Median(H+L)/2,5-Typical(H+L+C)/3,6-Weighted(H+L+C+C)/4",
				"0-SMA,1-EMA,2-SMMA,3-LWMA", "0-lines,1-dots ", 0, 1); 
				
	i2 = iCustom(NULL, 0, "VoltyChannel_Stop_v2.1M", 0, 1, 0, 10, 4, 1, true, false, 0, 0, 
				"0-C,1-O,2-H,3-L,4-Median(H+L)/2,5-Typical(H+L+C)/3,6-Weighted(H+L+C+C)/4",
				"0-SMA,1-EMA,2-SMMA,3-LWMA", "0-lines,1-dots ", 0, 2); 

	if (BuyTicket <= 0) {
		//  OrderBuy  
		
		if ((i1 < Close[0]) && (i2 > Close[0])) {
     		BuyTicket = OrderSend (Symbol(), OP_BUY, Lots, Ask, 3, NULL, NULL, NULL, Magic, 0, Blue);

     		if (BuyTicket < 0) {
	        	Print("OrderSend failed with error #",GetLastError());
        		return(0);
     		} else dsMakeStops(BuyTicket, StopLoss, TakeProfit, Magic);
		}
	
	} 
	
	

//----
   return(0);
  }
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
// 
void dsMakeStops(int Ticket,int StopLoss, int TakeProfit, int MagicNumber) {
	double newsl=0, newtp=0;
	bool mod=false;

	if (BuyTicket < 0) {
    	Print("OrderModify failed with error #", GetLastError());
		return(0);
	} 

	OrderSelect( Ticket, SELECT_BY_TICKET, MODE_TRADES);
	mod=false;
	if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) {
		if (OrderType()==OP_BUY) {
			if (StopLoss > 0) { newsl = OrderOpenPrice() - StopLoss * Point;}
			if (TakeProfit > 0) { newtp = OrderOpenPrice() + TakeProfit * Point;}
			mod=true;
		}

		if (OrderType()==OP_SELL) {
			if (StopLoss > 0) {newsl = OrderOpenPrice() + StopLoss * Point;}
			if (TakeProfit > 0) {newtp = OrderOpenPrice() - TakeProfit * Point;}
			mod=true;
		}
		
		if (mod==true) {
			while(IsTradeContextBusy()==true) {}
			OrderModify(OrderTicket(),OrderOpenPrice(),newsl,newtp,0,CLR_NONE);
		}
	}
	return(0);
}
//+------------------------------------------------------------------+


